# hebrew_errors.py

HEBREW_ERROR_TRANSLATIONS = {
    "ArithmeticError": "שגיאת חישוב",
    "AssertionError": "שגיאת בדיקה (assert)",
    "AttributeError": "שגיאה: לא קיים מאפיין כזה",
    "BaseException": "שגיאת בסיס",
    "BlockingIOError": "שגיאת קלט/פלט חסומה",
    "BrokenPipeError": "צינור נתונים שבור",
    "BufferError": "שגיאת באפר",
    "BytesWarning": "אזהרת בתים (bytes)",
    "ChildProcessError": "שגיאת תהליך בן",
    "ConnectionAbortedError": "החיבור הופסק",
    "ConnectionError": "שגיאת חיבור",
    "ConnectionRefusedError": "החיבור נדחה",
    "ConnectionResetError": "החיבור אופס",
    "DeprecationWarning": "אזהרת השבתה",
    "EOFError": "הגעת לסוף קובץ (EOF)",
    "EnvironmentError": "שגיאת סביבה",
    "Exception": "חריג כללי",
    "FileExistsError": "הקובץ כבר קיים",
    "FileNotFoundError": "הקובץ לא נמצא",
    "FloatingPointError": "שגיאת נקודה צפה",
    "FutureWarning": "אזהרת עתיד",
    "GeneratorExit": "יציאת גנרטור",
    "ImportError": "שגיאת ייבוא",
    "ImportWarning": "אזהרת ייבוא",
    "IndentationError": "שגיאת הזחה",
    "IndexError": "האינדקס מחוץ לטווח",
    "InterruptedError": "הפעולה הופסקה",
    "IsADirectoryError": "הקובץ הוא תיקיה",
    "KeyError": "המפתח לא נמצא במילון",
    "KeyboardInterrupt": "המשתמש הפסיק את הריצה (Ctrl+C)",
    "LookupError": "שגיאת חיפוש",
    "MemoryError": "אין מספיק זיכרון",
    "ModuleNotFoundError": "המודול לא נמצא",
    "NameError": "שם לא מוגדר",
    "NotADirectoryError": "זה לא תיקיה",
    "NotImplementedError": "הפעולה לא ממומשת",
    "OSError": "שגיאת מערכת הפעלה",
    "OverflowError": "חריגה מגבול ערך",
    "PendingDeprecationWarning": "אזהרת השבתה עתידית",
    "PermissionError": "אין הרשאה לפעולה",
    "ProcessLookupError": "תהליך לא נמצא",
    "RecursionError": "חריגה מעומק הרקורסיה",
    "ReferenceError": "שגיאת הפנייה לאובייקט שהושמד",
    "ResourceWarning": "אזהרת משאב",
    "RuntimeError": "שגיאת ריצה",
    "RuntimeWarning": "אזהרת ריצה",
    "StopAsyncIteration": "סיום איטרציה אסינכרונית",
    "StopIteration": "סיום איטרציה",
    "SyntaxError": "שגיאת תחביר",
    "SyntaxWarning": "אזהרת תחביר",
    "SystemError": "שגיאת מערכת",
    "SystemExit": "יציאה מהמערכת",
    "TabError": "שגיאת טאב בהזחה",
    "TimeoutError": "הפעולה חרגה מהזמן",
    "TypeError": "סוג לא מתאים",
    "UnboundLocalError": "משתנה מקומי לא מאותחל",
    "UnicodeDecodeError": "שגיאת פענוח יוניקוד",
    "UnicodeEncodeError": "שגיאת קידוד יוניקוד",
    "UnicodeError": "שגיאת יוניקוד",
    "UnicodeTranslateError": "שגיאת תרגום יוניקוד",
    "UnicodeWarning": "אזהרת יוניקוד",
    "UserWarning": "אזהרת משתמש",
    "ValueError": "ערך לא תקין",
    "Warning": "אזהרה",
    "ZeroDivisionError": "חלוקה באפס",
    "BlockingIOError": "קלט/פלט חסום",
    "FileNotFoundError": "קובץ לא נמצא",
    "IsADirectoryError": "הקובץ הוא תיקיה",
    "NotADirectoryError": "לא תיקיה",
    "PermissionError": "אין הרשאה",
    "ProcessLookupError": "תהליך לא נמצא",
    "TimeoutError": "הפעולה התעכבה",
    # הודעות טיפוסיות של traceback:
    "invalid syntax": "תחביר לא חוקי",
    "division by zero": "חלוקה באפס",
    "list index out of range": "אינדקס מחוץ לטווח הרשימה",
    "tuple index out of range": "אינדקס מחוץ לטווח הטופל",
    "string index out of range": "אינדקס מחוץ לטווח המחרוזת",
    "cannot import name": "לא ניתן לייבא את השם",
    "No module named": "המודול לא קיים",
    "unexpected indent": "הזחה לא צפויה",
    "unindent does not match any outer indentation level": "הזחה לא תואמת",
    "name is not defined": "השם לא מוגדר",
    "unsupported operand type(s)": "סוג אופרטור לא נתמך",
    "argument must be": "הארגומנט חייב להיות",
    "object has no attribute": "אין לאובייקט את המאפיין",
    "cannot concatenate": "לא ניתן לשרשר",
    "object is not callable": "האובייקט אינו ניתן לקריאה",
    "object is not iterable": "האובייקט אינו איטרבילי",
    "takes no arguments": "לא מקבל ארגומנטים",
    "missing required positional argument": "חסר ארגומנט חובה",
    "too many positional arguments": "יותר מדי ארגומנטים",
    "must be str, not": "חייב להיות מסוג str, לא",
    "expected str, bytes or os.PathLike object, not": "צפוי str, bytes או os.PathLike, לא",
    "cannot unpack non-iterable": "לא ניתן לפרק אובייקט לא איטרבילי",
    "local variable referenced before assignment": "משתנה מקומי הופנה לפני שהוגדר",
    "invalid literal for int()": "ערך לא חוקי עבור int()",
    "maximum recursion depth exceeded": "חריגה ממספר הרקורסיות המרבי",
    "module object is not callable": "המודול אינו ניתן לקריאה",
    "dictionary changed size during iteration": "המילון השתנה בזמן איטרציה",
    "object is not subscriptable": "האובייקט אינו תומך באינדוקס",
    # אפשר להרחיב עוד...
}

def print_hebrew_error(e):
    err_type = type(e).__name__
    err_msg = str(e)
    # חפש תרגום לפי סוג השגיאה
    hebrew = HEBREW_ERROR_TRANSLATIONS.get(err_type)
    # אם אין, חפש לפי טקסט ההודעה
    if not hebrew:
        for key in HEBREW_ERROR_TRANSLATIONS:
            if key in err_msg:
                hebrew = HEBREW_ERROR_TRANSLATIONS[key]
                break
    if not hebrew:
        hebrew = f"שגיאה לא מוכרת: {err_type}"
    print(f"שגיאה: {hebrew} ({err_type})")
    print(f"פרטים: {err_msg}")

# דוגמה לשימוש:
if __name__ == "__main__":
    try:
        eval("x===")
    except Exception as e:
        print_hebrew_error(e)
